Set Warnings "-notation-overridden,-parsing".
Require Import MoreStlc.
Parameter MISSING: Type.   

Module Check.  

Ltac check_type A B :=  
match type of A with  
| context[MISSING] => idtac "Missing:" A  
| ?T => first [unify T B; idtac "Type: ok" | idtac "Type: wrong - should be (" B ")"]  
end.  

Ltac print_manual_grade A :=  
first [  
match eval compute in A with  
| ?T => idtac "Score:" T  
end  
| idtac "Score: Ungraded"].  

End Check.

Require Import MoreStlc.
Import Check.

Goal True.

idtac "-------------------  STLC_extensions  --------------------".
idtac " ".

idtac "#> Manually graded: STLC_extensions".
idtac "Possible points: 1".
print_manual_grade STLC_extensions.
idtac " ".

idtac "#> STLCExtended.progress".
idtac "Possible points: 2".
check_type @STLCExtended.progress (
(forall (t : STLCExtended.tm) (T : STLCExtended.ty),
 STLCExtended.has_type (@Maps.empty STLCExtended.ty) t T ->
 STLCExtended.value t \/
 (exists t' : STLCExtended.tm, STLCExtended.step t t'))).
idtac "Assumptions:".
Abort.
Print Assumptions STLCExtended.progress.
Goal True.
idtac " ".

idtac "#> STLCExtended.substitution_preserves_typing".
idtac "Possible points: 1".
check_type @STLCExtended.substitution_preserves_typing (
(forall (Gamma : Maps.partial_map STLCExtended.ty) 
   (x : String.string) (U : STLCExtended.ty) (v t : STLCExtended.tm)
   (S : STLCExtended.ty),
 STLCExtended.has_type (@Maps.update STLCExtended.ty Gamma x U) t S ->
 STLCExtended.has_type (@Maps.empty STLCExtended.ty) v U ->
 STLCExtended.has_type Gamma (STLCExtended.subst x v t) S)).
idtac "Assumptions:".
Abort.
Print Assumptions STLCExtended.substitution_preserves_typing.
Goal True.
idtac " ".

idtac "#> STLCExtended.preservation".
idtac "Possible points: 1".
check_type @STLCExtended.preservation (
(forall (t t' : STLCExtended.tm) (T : STLCExtended.ty),
 STLCExtended.has_type (@Maps.empty STLCExtended.ty) t T ->
 STLCExtended.step t t' ->
 STLCExtended.has_type (@Maps.empty STLCExtended.ty) t' T)).
idtac "Assumptions:".
Abort.
Print Assumptions STLCExtended.preservation.
Goal True.
idtac " ".

idtac " ".

idtac "Max points - standard: 5".
idtac "Max points - advanced: 5".
Abort.
